/*
 * @(#)ezlmgetmachineinfo.cpp    1.00   02/21/02
 *
 * Copyright (c) 2002-2006 Agilis Software LLC, Santa Clara, CA, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Agilis Software LLC ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only
 * in accordance with the terms of the license agreement you entered
 * into with Agilis Software LLC.
 *
 */

#define __STRICT_ANSI__ 1

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <ctype.h>

#include <IlsPlat.h>

int douser = FALSE;

int main(int argc, char **argv)
{
	if (argc > 2 || argc == 1 || (strcmp(argv[1],"-h") && strcmp(argv[1],"-u"))) {
		fprintf(stderr, "\n*** usage: %s -{u|h} ***\n", argv[0]);
		fprintf(stderr, "\n    -h: include OS hostname to produce <<host>>");
		fprintf(stderr, "\n    -u: also include OS username to produce <<user>>@<<host>>");
		fprintf(stderr, "\n    Example: %s -u\n", argv[0]);
		exit(2);
	}

	douser = strcmp(argv[1],"-h") != 0;

	char osuser[100];
	osuser[0] = '\0';
	char oshost[500];
	oshost[0] = '\0';
#if defined(_WINDOWS)
	unsigned long namelen = sizeof(oshost);
	GetComputerName(oshost, &namelen);
	if (!oshost[0])
		goto oserr;
#elif defined(LINUX)
	struct utsname utsnamebuf;
	if (uname(&utsnamebuf) < 0)
		goto oserr;
	strcpy(oshost, &utsnamebuf.nodename[0]);
#else
	if (gethostname(oshost, sizeof(oshost)) < 0)
		goto oserr;
#endif
	if (douser) {
#if defined(_WINDOWS)
		unsigned long len = sizeof(osuser);
		if (!GetUserName(osuser, &len))
			goto oserr;
#else
		char *osuserx = getlogin();
		if (!osuserx)
			goto oserr;
		strcpy(osuser, osuserx);
#endif
	}
	if (douser)
		printf("%s@%s\n", osuser, oshost);
	else
		printf("%s\n", oshost);
	exit(0);
oserr:
	fprintf(stderr, "*** OS Error getting user / host info ***\n");
	exit(1);
	return 1;
}

